
/*--Include Files--*/
#include <windows.h>
#include <pro_ext.h>
#include <stdlib.h>
#include <string.h>

/*--Function Declarations--*/
void FAR CleanKill( void );
void FAR SayGoodBye( void );
void FAR KillActive(ParamBlk FAR *parm);
void FAR KillDead2(ParamBlk FAR *parm);
void FAR GetSetParms(ParamBlk FAR *parm);
void FAR NullTerminate(Value FAR *cVal);
BOOL FAR TimesUp( void );
BOOL FAR LookForFile( void );
void _export CALLBACK MyTimerProc(HWND foxwnd, WORD msg, WORD wParam, DWORD dwParam);

/*--Variable Declarations--*/
static DWORD        old_time;
static HWND         hWndMain;
static unsigned int TimerID,TimerFreq,TimerDur;
static BOOL         idle_on,dlg_up,countdown;
static char         filename[100];
static HINSTANCE    hinst;
static TIMERPROC    lpfnMyTimerProc;


/********************************************************************
*
* FUNCTION:    SayGoodBye( void )
*
* Type:        Internal Library Routine
*
* Description: Message to User that they are about to die...
*
*********************************************************************/
void FAR SayGoodbye( void )
{
  _Execute("SET BELL TO 1650-18,3");
  _Execute("?? CHR(7)");
  _Execute("SET BELL TO 650-5,3");
  _Execute("?? CHR(7)");
  _Execute("SET BELL TO 1650-18,3");
  _Execute("?? CHR(7)");
  _Execute("SET BELL TO 650-5,3");
  _Execute("?? CHR(7)");
  _Execute("SET BELL TO 1650-18,3");
  _Execute("?? CHR(7)");
  _Execute("SET BELL TO 650-5,3");
  _Execute("?? CHR(7)");

  _Execute("WAIT 'The System is Shut Down...Please Exit Immediately !' WIND TIME 5");
}


/********************************************************************
*
* FUNCTION:    MyTimerProc( ... )
*
* Type:        Internal Library Routine
*
* Description: The Timer Procedure that controls everything.
*
*********************************************************************/
void _export CALLBACK MyTimerProc(HWND foxwnd, WORD msg, WORD wParam, DWORD dwParam)
{
  if ( TimesUp() )
  {  
    if (countdown)
    {
      TimerDur -- ;
      FlashWindow(hWndMain,TRUE);
      if (TimerDur <= 0)
      {
        _Execute("QUIT");
        CleanKill();
      }
    }
    else
    {
      LookForFile();
    }
  }
}


/********************************************************************
*
* FUNCTION:    GetSetParms(ParamBlk FAR *parm)
*
* Type:        Internal Library Routine
*
* Description: Reassignment of passed parameters to static library
*              variables.
*
*********************************************************************/
void FAR GetSetParms(ParamBlk FAR *parm)
{
  WHANDLE wh;
  int     tfreq,tdur;

  /* Extract from Parameter List */
  NullTerminate(&parm->p[0].val);
  _StrCpy(filename,_HandToPtr(parm->p[0].val.ev_handle));
  tfreq = parm->p[1].val.ev_long ;
  tdur  = parm->p[2].val.ev_long ;
  TimerFreq = ( (tfreq <= 0) ? 1 : tfreq );
  TimerDur  = ( (tdur  <= 0) ? 1 : tdur  );

  /* Set Local Values */
  dlg_up    = FALSE;
  countdown = FALSE;
  idle_on   = TRUE;
  wh        = _WMainWindow();
  hWndMain  = _WhToHwnd(wh);
  old_time  = GetTickCount();

  /* Establish Timer */
  hinst = GetWindowWord(hWndMain, GWW_HINSTANCE);
  lpfnMyTimerProc = (TIMERPROC) MakeProcInstance(MyTimerProc, hinst);
  TimerID = SetTimer(hWndMain,1,(TimerFreq * 1000),lpfnMyTimerProc);
}


/********************************************************************
*
* FUNCTION:    NullTerminate(Value FAR *cVal)
*
* Type:        Internal Library Routine
*
* Description: Null terminates character strings passed from FoxPro.
*
*********************************************************************/
void FAR NullTerminate(Value FAR *cVal)
{
  if (!_SetHandSize(cVal->ev_handle,cVal->ev_length+1))
  {
    _Error(182);
  }
  ((char FAR *) _HandToPtr(cVal->ev_handle))[cVal->ev_length]='\0';
}


/********************************************************************
*
* FUNCTION:    LookForFile( void )
*
* Type:        Internal Library Routine
*
* Description: Look for the kill file.  If there, start the countdown.
*
*********************************************************************/
BOOL FAR LookForFile( void )
{
  FCHAN fchan;

  fchan = _FOpen(filename,FO_READONLY) ;

  if ( fchan == -1 )
  {
    return FALSE;
  }
  else
  {
    _FClose(fchan);

    KillTimer(hWndMain,TimerID);
    SayGoodBye();
    TimerFreq = 1 ;
    countdown = TRUE;
    TimerID = SetTimer(hWndMain,1,(TimerFreq * 1000),lpfnMyTimerProc);
    return TRUE;
  }  
}


/********************************************************************
*
* FUNCTION:    TimesUp( void )
*
* Type:        Internal Library Routine
*
* Description: Miller Time?
*
*********************************************************************/
BOOL FAR TimesUp( void )
{
  DWORD cur_time;

  cur_time = GetTickCount();

  if ( ((cur_time - old_time)/1000) >= TimerFreq )
  {
    old_time = cur_time ;
    return TRUE;
  }
  else
    return FALSE;
}


/********************************************************************
*
* FUNCTION:    KillActive(ParamBlk FAR *parm)
*
* Type:        Library Routine
*
* Description: Entry point to the whole shebang...
*
*********************************************************************/
void FAR KillActive(ParamBlk FAR *parm)
{
  if (idle_on)
  {
    CleanKill();
  }
  GetSetParms(parm);
}


/********************************************************************
*
* FUNCTION:    KillDead2(ParamBlk FAR *parm)
*
* Type:        Internal Library Routine
*
* Description: When the library is unloaded we must release the
*              Timer and Free the Proc Instance we Created.
*
*********************************************************************/
void FAR KillDead2(ParamBlk FAR *parm)
{
  CleanKill();
}


/********************************************************************
*
* FUNCTION:    KillDead(ParamBlk FAR *parm)
*
* Type:        Library Routine
*
* Description: When the library is unloaded we must release the
*              Timer and Free the Proc Instance we Created.
*
*********************************************************************/
void FAR KillDead(ParamBlk FAR *parm)
{
  CleanKill();
}


/********************************************************************
*
* FUNCTION:    CleanKill( void )
*
* Type:        Internal Library Routine
*
* Description: Clean up the mess you created...
*
*********************************************************************/
void FAR CleanKill( void )
{
  if (idle_on)
  {
    idle_on = FALSE;
    KillTimer(hWndMain,TimerID);
    FreeProcInstance(lpfnMyTimerProc);
  }
}


/*--FoxPro Needs to know what you got!--*/
FoxInfo myFoxInfo[] =
{
  {"KILLACTIVE", (FPFI) KillActive, 4,            "C,I,I,.?"},
  {"KILLDEAD",   (FPFI) KillDead,   0,            ""       },
  {"KILLDEAD2",  (FPFI) KillDead2,  CALLONUNLOAD, ""       }
};

FoxTable _FoxTable =
{
	(FoxTable FAR *) 0, sizeof(myFoxInfo)/sizeof(FoxInfo), myFoxInfo
};

/*--EOF--*/